<?php

# Copyright (c) 2013 Shin Fujihara
# Licensed under the MIT license

require_once( config_get( 'class_path' ) . 'MantisPlugin.class.php' );

class MantisAvatarPlugin extends MantisPlugin {
    function register() {
		# プラグインの名称
        $this->name = 'MantisAvatar';
        # プラグインの詳細
		$this->description = 'Mantis独自のアバターを設定';
        # 初期ページ
        $this->page = 'config';
		# プラグインのバージョン
        $this->version = '0.1';
        # 必要なMantisCoreのバージョン
        $this->requires = array('MantisCore' => '1.2.0',);
        # 作成者
        $this->author = 'Shin Fujihara';
        # 作成者のアドレス
        $this->contact = '';
        # サポートページ
        $this->url = '';
    }
    
    # フックするイベントの指定
    function hooks() {
		$hooks = array(
				'EVENT_VIEW_BUGNOTES_START' => 'avatar_start',
				'EVENT_VIEW_BUGNOTES_END' => 'avatar_end',
			);
		return $hooks;
	}
	
	function avatar_start($event, $f_bug_id, $t_bugnotes) {
    	echo "<script type=\"text/javascript\">\n<!--\n";
    	echo 'var mantis_custom_avatar = {';
    	
    	$isout = false;
    	$num_notes = count( $t_bugnotes );
    	for ( $i=0; $i < $num_notes; $i++ ) {
    		$t_bugnote = $t_bugnotes[$i];
    		
    		$p_id = $t_bugnote->id;
    		$p_user_id = $t_bugnote->reporter_id;
    		
    		if( !user_exists( $p_user_id ) ) {
    			continue;
    		}
    		
    		// note_idとその報告をしたレポーターのidを関連付け
    		if ($isout) {
    			echo ",";
    		}
    		echo "'c{$p_id}' : {$p_user_id}";
    		$isout = true;
    	}
    	echo "};\n";
    	echo "//-->\n</script>\n";
	}
	

	function avatar_end($event, $f_bug_id) {
?>
<script type="text/javascript">
<!--
	for (key in mantis_custom_avatar) {
		var obj = document.getElementById(key);
		if (obj == null) {
			continue;
		}
		var td = obj.getElementsByTagName('td').item(0);
		var span = td.getElementsByTagName('span').item(0);
		var img = document.createElement('img');
		img.setAttribute('class', 'avatar');
		img.setAttribute('className', 'avatar');
		img.src = '<?php echo plugin_page( "image" ) ?>&id=' + mantis_custom_avatar[key];
		td.insertBefore(img, span);
	}
//-->
</script>
<?php
	}




	public function schema() {
		return array(
			array("CreateTableSQL", array(plugin_table("avatar"), "
				id				I			NOTNULL UNSIGNED PRIMARY,
				mime			C(20)		NOTNULL,
				avater			B			NOTNULL
				")),
		);
	}
	
	//public function uninstall() {
	//	db_query( "DROP TABLE " . plugin_table("avatar"));
	//}

}
